# Enum rustc_trait_selection::traits::BuiltinImplSource

source ·

    pub enum BuiltinImplSource {
        Misc,
        Object {
            vtable_base: usize,
        },
        TraitUpcasting {
            vtable_vptr_slot: Option<usize>,
        },
        TupleUnsizing,
    }

## Variants§

§

### Misc

Some builtin impl we don’t need to differentiate. This should be used unless more specific information is necessary.

§

### Object

#### Fields

§`vtable_base: usize`

A builtin impl for trait objects.

The vtable is formed by concatenating together the method lists of the base object trait and all supertraits, pointers to supertrait vtable will be provided when necessary; this is the start of `upcast_trait_ref`’s methods in that vtable.

§

### TraitUpcasting

#### Fields

§`vtable_vptr_slot: Option<usize>`

The vtable is formed by concatenating together the method lists of the base object trait and all supertraits, pointers to supertrait vtable will be provided when necessary; this is the position of `upcast_trait_ref`’s vtable within that vtable.

§

### TupleUnsizing

Unsizing a tuple like `(A, B, ..., X)` to `(A, B, ..., Y)` if `X` unsizes to `Y`.

This needs to be a separate variant as it is still unstable and we need to emit a feature error when using it on stable.

## Auto Trait Implementations§

§

### impl RefUnwindSafe for BuiltinImplSource

§

### impl Send for BuiltinImplSource

§

### impl Sync for BuiltinImplSource

§

### impl Unpin for BuiltinImplSource

§

### impl UnwindSafe for BuiltinImplSource

## Blanket Implementations§

source§

### impl<T> Any for T
where T: 'static + ?Sized,

source§

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more
source§

### impl<T> Borrow<T> for T
where T: ?Sized,

source§

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more
source§

### impl<T> BorrowMut<T> for T
where T: ?Sized,

source§

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more
source§

### impl<T> From<T> for T

source§

#### fn from(t: T) -> T

Returns the argument unchanged.

source§

### impl<T, U> Into<U> for T
where U: From<T>,

source§

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

source§

### impl<T> ToOwned for T
where T: Clone,

§

#### type Owned = T

The resulting type after obtaining ownership.
source§

#### fn to_owned(&self) -> T

Creates owned data from borrowed data, usually by cloning. Read more
source§

#### fn clone_into(&self, target: &mut T)

Uses borrowed data to replace owned data, usually by cloning. Read more
source§

### impl<T, U> TryFrom<U> for T
where U: Into<T>,

§

#### type Error = Infallible

The type returned in the event of a conversion error.
source§

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.
source§

### impl<T, U> TryInto<U> for T
where U: TryFrom<T>,

§

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.
source§

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.

## Layout§

Note: Most layout information is completely unstable and may even differ between compilations. The only exception is types with certain `repr(...)` attributes. Please see the Rust Reference's “Type Layout” chapter for details on type layout guarantees.

Size: 16 bytes

Size for each variant:

- `Misc`: 0 bytes
- `Object`: 16 bytes
- `TraitUpcasting`: 16 bytes
- `TupleUnsizing`: 0 bytes